# 夜勤スケジューリング V2.0
#py -m pip install pulp
#py -m pip install ortoolpy
#py -m pip install pandas #エラー発生の場合 コントロールパネル システム環境変数設定 
# python d\nscj\nscj.py
# 8名×14日
# 条件
#1日の日勤 2名 夜勤2名
#各看護師について
# 休日数7日 日勤夜勤日数 4日以下 
# 週末 連休 1回
# 連続勤務 4日以下 
# 夜勤の翌日の日勤は不可
# 夜勤3連続まで
# 4連休を避ける
# 前後の日が休み間の出勤避ける

import numpy as np, pandas as pd
from pulp import *
from ortoolpy import addvars, addbinvars
import random
import time
#
m = LpProblem() # 数理モデル
看護師数=8
日数=14
V割当 = np.array(addbinvars(3,看護師数, 日数)) #次元0  0休み　1日勤　2夜勤 
# ランダムな結果を出すためランダムな評価を加える
#rr=np.random.rand(看護師数,日数)
#rr=(np.clip(rr,0.9,1.0)-0.9)/100 #0.9以下は0
#m +=lpDot(V割当[0],rr)  ##この評価は時間バラツキ大きい
# 下の方法も時間バラツキ大きいが何をやっているか明確
jj=[]
for i in range(看護師数):
    jj.append(random.randrange(日数)) #この日の出勤の可能性を下げる
m +=(V割当[1,0,jj[0]]
    +V割当[1,1,jj[1]]
    +V割当[1,2,jj[2]]
    +V割当[1,3,jj[3]]
    +V割当[1,4,jj[4]]
    +V割当[1,5,jj[5]]
    +V割当[1,6,jj[6]]
    +V割当[1,7,jj[7]])
     
#0休み　1日勤　2夜勤 のどれかが1
for i in range(看護師数):
    for j in range(日数):
        m += lpSum(V割当[:,i,j])==1

#1日の日勤 2名 夜勤2名
for j in range(日数):
    m +=  lpSum(V割当[1,:,j])==2 #日勤数
    m +=  lpSum(V割当[2,:,j])==2 #夜勤数

#休日数7日 日勤夜勤日数 4日以下 
for i in range(看護師数):
    m +=  lpSum(V割当[0,i,:])==7 #休日数
    m +=  lpSum(V割当[1,i,:])<=4 #夜勤数
    m +=  lpSum(V割当[2,i,:])<=4 #夜勤数

#週末 連休 1回
ya1=[0,0,0,0,0,1,1,0,0,0,0,0,1,1]
ya2=[0,0,0,0,0,0,1,0,0,0,0,0,0,1]
ya3=[0,0,0,0,0,0,1,0,0,0,0,0,1,0]
ya4=[0,0,0,0,0,1,0,0,0,0,0,0,0,1]
ya5=[0,0,0,0,0,1,0,0,0,0,0,0,1,0]
for i in range(看護師数):
    m +=lpDot(V割当[0,i,:],ya1)==2
    m +=lpDot(V割当[0,i,:],ya2)==1
    m +=lpDot(V割当[0,i,:],ya3)==1
    m +=lpDot(V割当[0,i,:],ya4)==1
    m +=lpDot(V割当[0,i,:],ya5)==1

    
#連続勤務 4日以下 (5日間の間に休みがある)
for i in range(看護師数):
    for j in range(日数-5+1):
        ch=np.zeros(日数,dtype=np.int)
        ch[j:j+5]=1 #5日連続1
        m += lpDot(V割当[0,i,:],ch)>=1 #5日中休みが1日以上ある

#夜勤の翌日の日勤は不可
for i in range(看護師数):
    for j in range(日数-2+1):
        m += V割当[2,i,j]+V割当[1,i,j+1] <=1 # 夜勤の次の日が日勤では2となる
        
#夜勤3連続まで  3日間の夜勤が3未満
for i in range(看護師数):
    for j in range(日数-3+1):
        ch=np.zeros(日数,dtype=np.int)
        ch[j:j+3]=1 #5日連続1
        m += lpDot(V割当[2,i,:],ch)<=2 #3日中 夜勤は2日

#4連休を避ける　4日間の休みが休み3日以下
for i in range(看護師数):
    for j in range(日数-4+1):
        ch=np.zeros(日数,dtype=np.int)
        ch[j:j+4]=1 #4日連続1
#        print(ch)
        m += lpDot(V割当[0,i,:],ch)<=3 #4日中 休み3日


#前後の日が休み間の出勤避ける
for i in range(看護師数):
    for j in range(日数-3+1):
        m += V割当[0,i,j]+(1-V割当[0,i,j+1])+ V割当[0,i,j+2]<=2 # 休　出勤　休み　でない


m.solve()

R結果 = np.vectorize(value)(V割当).astype(int)
R結果2=np.zeros((看護師数,日数),dtype=np.int)

for i in range(看護師数):
    for j in range(日数):
        for k in range(3):
            if R結果[k,i,j]==1:
                R結果2[i,j]=k

df= pd.DataFrame(R結果2) #データフレームへ
ppath = os.getcwd() #プログラムのホルダ
df.to_csv(ppath+'\\nscjk.csv',index=False,header=False) #csv出力

print(R結果2)
print('ファイル出力',ppath+'\\nscjk.csv')    
time.sleep(3) #3秒待つ
